#ifndef CYGONCE_JNS200_H
#define CYGONCE_JNS200_H

/*=============================================================================
//
//      jns200.h
//
//      Platform specific support (register layout, etc)
//
//=============================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// http://www.redhat.com/                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000, 2001 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    Jesse Off
// Contributors: Jesse Off
// Date:         2004-07-23
// Purpose:      Technologic Systems TS-7250 (JNS200) platform specific information
// Description: 
// Usage:        #include <cyg/hal/jns200.h>
//
//####DESCRIPTIONEND####
//
//===========================================================================*/

#include <cyg/infra/cyg_type.h>

#define JNS200_WATCHDOG_FEED	0x23c00000
#define JNS200_WATCHDOG_CTRL	0x23800000
#define JNS200_STATUS		0x10800000
#define JNS200_JP6		0x22800000

externC cyg_bool jns200_jp_enabled(int);
externC cyg_bool jns200_ram_present(unsigned long);

/*---------------------------------------------------------------------------*/
/* end of jns200.h                                                           */
#endif /* CYGONCE_JNS200_H */
