#ifndef CYGONCE_TS7200_H
#define CYGONCE_TS7200_H

/*=============================================================================
//
//      ts7200.h
//
//      Platform specific support (register layout, etc)
//
//=============================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// http://www.redhat.com/                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000, 2001 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    Jesse Off
// Contributors: Jesse Off
// Date:         2004-07-23
// Purpose:      Technologic Systems TS-7200 platform specific information
// Description: 
// Usage:        #include <cyg/hal/ts7200.h>
//
//####DESCRIPTIONEND####
//
//===========================================================================*/

#include <cyg/infra/cyg_type.h>

#define TS7200_WATCHDOG_FEED	0x23c00000
#define TS7200_WATCHDOG_CTRL	0x23800000
#define TS7200_IDE8_BASE	0x11000000
#define TS7200_IDE_ALTSTATUS	0x10400006
#define TS7200_IDE16_BASE	0x21000000
#define TS7200_STATUS		0x10800000
#define TS7200_JP6		0x22800000

externC cyg_bool ts7200_jp_enabled(int);
externC int ts7200_ram_present(unsigned long);

/*---------------------------------------------------------------------------*/
/* end of ts7200.h                                                           */
#endif /* CYGONCE_TS7200_H */
